package org.thechiselgroup.choosel.visualization_component.chart.client.concernlines;

import org.thechiselgroup.choosel.core.client.resources.DataType;
import org.thechiselgroup.choosel.core.client.views.model.Slot;
import org.thechiselgroup.choosel.protovis.client.PV;
import org.thechiselgroup.choosel.protovis.client.PVEventHandler;
import org.thechiselgroup.choosel.protovis.client.jsutil.JsArgs;
import org.thechiselgroup.choosel.protovis.client.jsutil.JsDoubleFunction;
import org.thechiselgroup.choosel.visualization_component.chart.client.ChartViewContentDisplay;

public class ConcernLines extends ChartViewContentDisplay {

    public static final String ID = "org.thechiselgroup.choosel.visualization_component.chart.concernLines";

    public final static Slot LABEL = new Slot("label", "Label", DataType.TEXT);

    public final static Slot ZERO_COLOR = new Slot("zeroColor", "0 Color",
            DataType.COLOR);

    public final static Slot LOW_COLOR = new Slot("lowColor", "Low Color",
            DataType.COLOR);

    public final static Slot MIDDLE_COLOR = new Slot("middleColor",
            "Middle Color", DataType.COLOR);

    public final static Slot HIGH_COLOR = new Slot("highColor", "High Color",
            DataType.COLOR);

    public final static Slot SLICE_INTENSITY = new Slot("slice intensity",
            "Slice Intensity", DataType.NUMBER);

    public static final Slot[] SLOTS = new Slot[] { LABEL, LOW_COLOR,
            MIDDLE_COLOR, HIGH_COLOR, SLICE_INTENSITY };

    private JsDoubleFunction regularBarLength = new JsDoubleFunction() {
        @Override
        public double f(JsArgs args) {
            return 100.0d;
        }
    };

    private JsDoubleFunction regularBarHeight = new JsDoubleFunction() {
        @Override
        public double f(JsArgs args) {
            return 50.0d;
        }
    };

    @Override
    protected void afterRender() {
        super.afterRender();
    }

    @Override
    protected void beforeRender() {
        super.beforeRender();

    }

    @Override
    protected void buildChart() {

        getChart().add(PV.Bar).data(viewItemsJsArray).width(regularBarLength)
                .height(regularBarHeight);

    }

    protected double calculateBarLength(double d) {
        return 100;
    }

    @Override
    public String getName() {
        return "Concern Lines";
    }

    @Override
    public Slot[] getSlots() {
        return SLOTS;
    }

    @Override
    protected void registerEventHandler(String eventType, PVEventHandler handler) {

    }
}
